  
'' 
''
CON
  _clkmode = xtal1 + pll16x        'Sets the clock speed to 80 MHz using a times 16 multiplier
  _xinfreq = 5_000_000             'Crystal speed: 5 MHz

  LCD_Pin                       = 10                        
  LCD_Baud                      = 19_200                   
  LCD_Lines                     = 4
  
   
  Btn_Up                        =11   'Left_Button 
  Btn_Down                      =12   'Middle_Button
  Btn_Select                    =13   'Right_Button
  Btn_Escape                    =14   'bottom button
                                                        

  Off                           = 0
  On                            = 1

   
  
VAR
                      
  LONG  Stack0[150]        'FOR UPDATES_LCD
  LONG  Stack1[150]        'FOR PROCESS_ECU
  LONG  Stack2[150]        'FOR BUTTON_PUSH
  '==========UPDATE LCD
  BYTE  MENU
  BYTE  SUBMENU
  BYTE  FUNCTION
  BYTE  CURRENTMENU
  BYTE  CURRENTPROMPT
  BYTE  txByte             ' transmit byte
  BYTE  rxByte             ' recv byte 
  '==========BUTTON PUSH
  BYTE  Button_Push_Flag   
  
OBJ

  LCD           : "Serial_Lcd"

  
PUB Start    

  
    
  CogNew(UPDATES_LCD, @Stack0)                  
 
  CogNew(BUTTON_PUSH, @Stack2)  

 
PUB UPDATES_LCD  |  mnuStr, offset, TEMP

    If LCD.init(LCD_Pin, LCD_Baud, LCD_Lines)     'Initialize LCD
      LCD.Cursor(Off)                         
      LCD.Backlight(On)                       
      LCD.Cls
      PAUSE(100)      '100ms

        
REPEAT
  LCD.Line_1                'got rid of the prompt
  case MENU
    0: mnuStr := @MAINMENU
    1: mnuStr := @MOTRONICMENU                ' different length
    2: mnuStr := @OTHERMENU                   'other menus all the same length
  offset:= BYTE[@LineOffset + CURRENTPROMPT]
  LCD.str(mnuStr + offset)
  LCD.Line_1
  LCD.putc(LCD#LCD_PROMPT)

  LCD.Line_2  
  IF CURRENTPROMPT == lookupz( MENU : 6, 3, 3 )   
    offset := 0                       'roll over                                                                                                                                                                                                                                                                                                                                                                                                                                                                     
  ELSE
    offset := offset + 21
  IF MENU == 0
      mnuStr := @MAINMENU
  IF MENU == 1
      mnuStr := @MOTRONICMENU
  IF MENU == 2
      mnuStr := @OTHERMENU  
  LCD.str(mnuStr + offset)
  
  LCD.Line_3
   offset := offset + 21
  
  IF CURRENTPROMPT == lookupz( MENU : 6, 6, 3 ) 
    offset := 21
  ELSEIF CURRENTPROMPT == lookupz( MENU : 5, 5, 2 )  
      offset := 0
  IF MENU == 0
      mnuStr := @MAINMENU
  IF MENU == 1
      mnuStr := @MOTRONICMENU
  IF MENU == 2
      mnuStr := @OTHERMENU
  LCD.str(mnuStr + offset)
 
  LCD.Line_4
  offset := offset + 21   
  IF CURRENTPROMPT == lookupz( MENU : 6, 6, 3 ) 
     offset := 42
  ELSEIF CURRENTPROMPT == lookupz( MENU : 5, 5, 2 )
     offset := 21
  ELSEIF CURRENTPROMPT == lookupz( MENU : 4, 4, 1 )  
     offset := 0   
  IF MENU == 0
      mnuStr := @MAINMENU
  IF MENU == 1
      mnuStr := @MOTRONICMENU
  IF MENU == 2
      mnuStr := @OTHERMENU
  LCD.str(mnuStr + offset)
  

PUB BUTTON_PUSH  | newstate, oldstate, xstate, TEMP
'  Btn_Up                        =11   'Left_Button 
'  Btn_Down                      =12   'Middle_Button
'  Btn_Select                    =13   'Right_Button
'  Btn_Escape                    =14   'bottom button
' have all the possible commands for selection, with a command flag.  PROCESS_ECU will then use this to make a case selection.
   oldstate := inA[14..11]   ' initial state of input pins
   REPEAT
     newstate := inA[14..11]   ' current state of input pins
     xstate := newstate ^ oldstate & newstate   ' detect change of 1 to 4 bits, 0->1
     oldstate := newstate   ' push state down
     
     IF xstate & |<0            'the bits 14..11 are shifted to 3..0 in xstate
       PAUSE(40)                 ' call method for Pin11 "UP"
       REPEAT until inA[11]
       -- CURRENTPROMPT
       TEMP := lookupz( MENU : 6, 6, 3 )
       IF CURRENTPROMPT == $FF
        CURRENTPROMPT := TEMP
                   
     IF xstate & |<1
       PAUSE(40)                 ' call method for Pin12  "DOWN"
       REPEAT until inA[12]
       ++CURRENTPROMPT
       TEMP := lookupz( MENU : 6, 6, 3 )
       IF CURRENTPROMPT > TEMP
        CURRENTPROMPT := 0
     
     IF xstate & |<2 AND  Button_Push_Flag := Off       'can't select if currently processing a command 
      PAUSE(40)                 ' call method for Pin13  "SELECT"
       REPEAT until inA[13]
       ++ Menu
       SUBMENU := CURRENTPROMPT
       CURRENTPROMPT := 0
       Button_Push_Flag := On   'selection has been made, not processed
       
     IF xstate & |<3
       PAUSE(40)                ' call method for Pin14    "ESCAPE"
       REPEAT until inA[14]             
       -- MENU
       CURRENTPROMPT := 0
       
    PAUSE(40)

PUB PAUSE(millisecs)                          'As set up here it is .25 millisceconds
  waitcnt(((((clkfreq)/1000))*millisecs) +cnt)   'Osc speed is 40 MHz


  
DAT


MAINMENU   ' use with "Select System:" and "Up     Down   Select" 
        BYTE " Motronic           ", 0  'CURRENTPROMPT = 0
        BYTE " Climate Control    ", 0  'CURRENTPROMPT = 1
        BYTE " ABS                ", 0  'CURRENTPROMPT = 2
        BYTE " Airbag             ", 0  'CURRENTPROMPT = 3
        BYTE " Tiptronic          ", 0  'CURRENTPROMPT = 4
        BYTE " Alarm              ", 0  'CURRENTPROMPT = 5
        BYTE " PDAS               ", 0  'CURRENTPROMPT = 6

MOTRONICMENU   ' use with "Select Function:" and "Up     Down   Select"    
        BYTE " Get Error Codes    ", 0 ,$07
        BYTE " Clear Codes        ", 0
        BYTE " Actual Values      ", 0
        BYTE " Activate Outputs   ", 0
        BYTE " System Adaption    ", 0
        BYTE " RPM                ", 0
        BYTE " Knock Counter      ", 0
        
OTHERMENU   ' use with "Select Function:" and "Up     Down   Select"    
        BYTE " Get Error Codes    ", 0 ,$07
        BYTE " Clear Codes        ", 0 ' clear codes?
        BYTE " Actual Values      ", 0
        BYTE " Activate Outputs   ", 0


              
       
LineOffset
        BYTE  0, 21, 42, 63, 84, 105, 126, 148, 169   ' line width + 1 (for 0)
       